// packageI/offline_investment/offlineInvestmentExtension/offlineInvestmentExtension.js
var app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    info: {},
    activeRole: '',
    activeName: 0,
    titleArr: ["全部", "未结算", "已结算"],
    dataList: [],
    isLoadMore: true,
    networkLoading: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.init();
  },

  init() {
    let dataList = [];
    this.data.titleArr.forEach((val, index) => {
      dataList.push({
        isLoadMore: true,
        page: 1,
        total_page: 0,
        list: []
      });
    });
    this.setData({
      dataList: dataList,
      isLoadMore: true
    });
    this.getData();
  },

  getData() {
    this.setData({
      networkLoading: true
    });
    let urlStr = app.getNetAddresss("plugin.merchant-meeting.frontend.index.bonus-info");
    app._getNetWork({
      url: urlStr,
      data: {},
      success: (resdata) => {
        var res = resdata.data;
        if (res.result == 1) {
          wx.setNavigationBarTitle({
            title: res.data.plugin_name
          });
          this.setData({
            networkLoading: false,
            info: res.data,
            activeRole: res.data.lecturer ? 1 : 2, //身份类型，1讲师，2后勤
            ['dataList[0].isLoadMore']: true,
            ['dataList[0].total_page']: res.data.bonusStatistic.bonusList.last_page,
            ['dataList[0].list']: res.data.bonusStatistic.bonusList.data
          });

        } else {
          wx.showToast({
            title: res.msg,
            icon: 'none',
            duration: 1000
          });
        }
      },
      fail: function (res) {
        console.log(res);
      }
    });
  },
  changeRole(e) {
    // 切换角色
    this.setData({
      activeRole: e.detail.name
    });
    let dataList = [];
    this.data.titleArr.forEach((val, index) => {
      dataList.push({
        isLoadMore: true,
        page: 1,
        total_page: 0,
        list: []
      });
    });
    this.setData({
      dataList: dataList,
      activeName: 0
    });
    this.handleClick();
  },
  tabClick(e) {
    this.setData({
      activeName: e.detail.index
    });
    this.handleClick();
  },

  handleClick(e) {
    this.setData({
      networkLoading: true
    });
    let that = this;
    if (this.data.dataList[that.data.activeName].list.length > 0) {
      that.data.isLoadMore = this.data.dataList[that.data.activeName].isLoadMore;
      return;
    }

    let urlStr = app.getNetAddresss("plugin.merchant-meeting.frontend.index.bonus-statistic");
    app._getNetWork({
      url: urlStr,
      data: {
        page: 1,
        business_type: that.data.activeRole,
        status: that.data.activeName - 1
      },
      success: function (resdata) {
        var res = resdata.data;
        if (res.result == 1) {
          that.setData({
            networkLoading: false,
            isLoadMore: true,
            ['dataList[' + that.data.activeName + '].isLoadMore']: true,
            ['dataList[' + that.data.activeName + '].total_page']: res.data.bonusList.last_page,
            ['dataList[' + that.data.activeName + '].list']: res.data.bonusList.data
          });

        } else {
          wx.showToast({
            title: res.msg,
            icon: 'none',
            duration: 1000
          });
        }
      },
      fail: function (res) {
        console.log(res);
      }
    });
  },
  _getMoreData() {
    let that = this;
    this.setData({
      ['dataList[' + that.data.activeName + '].isLoadMore']: false
    });
    if (this.data.dataList[this.data.activeName].page >= this.data.dataList[this.data.activeName].total_page) {
      return;
    } else {
      this.data.dataList[this.data.activeName].page = this.data.dataList[this.data.activeName].page + 1;
      let urlStr = app.getNetAddresss('plugin.merchant-meeting.frontend.index.bonus-statistic');
      urlStr += "&page=" + this.data.dataList[this.data.activeName].page;

      app._getNetWork({
        url: urlStr,
        data: {
          business_type: that.data.activeRole,
          status: that.data.activeName - 1
        },
        success: function (resdata) {
          var res = resdata.data;
          if (res.result == 1) {
            let myData = res.data.bonusList.data;
            that.setData({
              ['dataList[' + that.data.activeName + '].isLoadMore']: true,
              ['dataList[' + that.data.activeName + '].list']: that.data.dataList[that.data.activeName].list.concat(myData.data)
            });
          } else {
            that.setData({
              ['dataList[' + that.data.activeName + '].isLoadMore']: false,
              ['dataList[' + that.data.activeName + '].page']: that.data.dataList[that.data.activeName].page - 1
            });
          }
        },
        fail: function (res) {
          console.log(res);
        }
      });
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if (this.data.dataList[this.data.activeName].isLoadMore) {
      this._getMoreData();
    } else {
      console.log('没有更多数据');
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
});